import 'dart:io';

import 'package:cli_a2soft/bricks/bloc_item_bundle.dart';
import 'package:cli_a2soft/cli/cli_mixin.dart';
import 'package:args/command_runner.dart';
import 'package:mason/mason.dart';

class BlocCommand extends Command with CLIMixin {
  BlocCommand();

  @override
  String get description => "Создает BLoC-компонент по шаблону A2Soft";

  @override
  String get name => "bloc";

  @override
  Future<void> run() async {
    /// Запрашиваем путь для будущего BLoC'а
    final currentDirectory = "Текущая директория";
    final pathToBloc = getUserInput<String>(
      helpPhrase: "Введите путь для создание BLoC'а",
      defaultValue: currentDirectory,
    );

    /// Запрашиваем название для будущего блока
    final blocName = getUserInput<String>(
      helpPhrase: "Введите название BLoC'а",
      defaultValue: "Sample",
    );

    late final Directory directory;
    if (pathToBloc == currentDirectory) {
      directory = Directory.current;
    } else {
      directory = Directory(pathToBloc);
    }

    await generateBLoCSamples(directory, blocName);
  }

  Future<void> generateBLoCSamples(Directory directory, String blocName) async {
    final generator = await MasonGenerator.fromBundle(blocItemBundle);
    await generator.generate(DirectoryGeneratorTarget(directory), vars: {"bloc_name": blocName});
  }
}
