part of "create_command.dart";

Future<void> generateProjectSamples({
  required Directory projectDir,
  required String projectName,
  bool enableLocalization = false,
  bool enableDatabase = false,
}) async {
  final generator = await MasonGenerator.fromBundle(projectCodeSamplesBundle);
  final libDir = Directory(projectDir.path + "/lib");
  await generator.generate(
    DirectoryGeneratorTarget(libDir),
    vars: {
      "project_name": projectName,
      "is_localization": enableLocalization,
      "is_database": enableDatabase,
    },
  );
}
